CREATE TABLE `course_dimension` (
    `id` BIGINT(20) NOT NULL COMMENT 'id',
    `school_id` BIGINT(20) NOT NULL COMMENT '学校id',
    `semester_id` BIGINT(20) NOT NULL COMMENT '学期id',
    `exam_id` BIGINT(20) NOT NULL COMMENT '考试id',
    `course_code` VARCHAR(20) NOT NULL COMMENT '课程编号',
    `code` VARCHAR(32) NOT NULL COMMENT '知识点编号',
    `name` VARCHAR(255) NOT NULL COMMENT '知识点名称',
    `number` INT NOT NULL COMMENT '排序',
    `parent_id` BIGINT(20) NOT NULL COMMENT '父id（顶级知识点父id为0）',
    `create_id` BIGINT(20) NULL COMMENT '创建人',
    `create_time` BIGINT(20) NULL COMMENT '创建时间',
    `update_id` BIGINT(20) NULL COMMENT '更新人',
    `update_time` BIGINT(20) NULL COMMENT '更新时间',
    PRIMARY KEY (`id`)
)  ENGINE=INNODB DEFAULT CHARACTER SET=UTF8MB4 COMMENT='课程知识点表';

ALTER TABLE `teach_course` 
ADD COLUMN `weight_setting` TINYINT(1) NULL COMMENT '权重设置' AFTER `enable`,
ADD COLUMN `exam_id` BIGINT NOT NULL COMMENT '考试id' AFTER `school_id`,
ADD COLUMN `course_code` VARCHAR(20) NOT NULL COMMENT '课程编号' AFTER 'exam_id',
CHANGE COLUMN `user_id` `user_id` BIGINT NOT NULL COMMENT '任课教师id' ,
DROP INDEX `teach_course_unique` ,
ADD UNIQUE INDEX `teach_course_unique` (`school_id` ASC, `exam_id` ASC, `course_code` ASC, `user_id` ASC) INVISIBLE;
;

ALTER TABLE `course_dimension` 
ADD COLUMN `teach_course_id` BIGINT NOT NULL COMMENT '教学课程id' AFTER `id`,
ADD COLUMN `user_id` BIGINT NOT NULL COMMENT '教师id' AFTER `course_code`,
ADD COLUMN `source` VARCHAR(20) NOT NULL COMMENT '来源' AFTER `user_id`;
ALTER TABLE `course_dimension` 
DROP INDEX `course_dimension_unique` ,
ADD UNIQUE INDEX `course_dimension_unique` (`teach_course_id` ASC, `source` ASC, `code` ASC) INVISIBLE;
;

ALTER TABLE `course_evaluation` 
ADD COLUMN `teach_course_id` BIGINT NOT NULL COMMENT '教学课程id' AFTER `id`,
ADD COLUMN `user_id` BIGINT NOT NULL COMMENT '教师id' AFTER `course_code`,
ADD COLUMN `type` VARCHAR(20) NOT NULL COMMENT '类型（默认DEFAULT、自定义CUSTOM）' AFTER `user_id`,
DROP INDEX `course_evaluation_unique` ,
ADD UNIQUE INDEX `course_evaluation_unique` (`teach_course_id` ASC, `evaluation` ASC) VISIBLE;
;

ALTER TABLE `course_target` 
ADD COLUMN `teach_course_id` BIGINT NOT NULL COMMENT '教学课程id' AFTER `id`,
ADD COLUMN `user_id` BIGINT NOT NULL COMMENT '教师id' AFTER `course_code`,
DROP INDEX `course_target_unique` ,
ADD UNIQUE INDEX `course_target_unique` (`teach_course_id` ASC, `target_name` ASC) VISIBLE;
;

ALTER TABLE `course_weight` 
ADD COLUMN `teach_course_id` BIGINT NOT NULL COMMENT '教学课程id' AFTER `id`,
ADD COLUMN `user_id` BIGINT NOT NULL COMMENT '教师id' AFTER `course_code`,
DROP INDEX `course_weight_unique` ,
ADD UNIQUE INDEX `course_weight_unique` (`teach_course_id` ASC, `target_id` ASC, `evaluation_id` ASC) INVISIBLE;
;

